package edu.qrg.vmodel.controllers.classic;

import edu.qrg.vmodel.*;
import edu.qrg.vmodel.VModel.*;
import edu.qrg.utils.*;
import edu.qrg.vmodel.controllers.common.*;
import java.util.*;
import javax.swing.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Controller.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
* Interface: Controller
*   Purpose: Controller API.
* ----------------------------------------------------------------------------
* Notes:
* * Very simple to suit the task in VModel.
* * Need to add a toolbar with forward/backward
* -----------------------------------------------------------------------------
* </PRE> */
public interface Controller extends VModelConstants, edu.qrg.vmodel.VModel.VMController {
	// Properties & Accessors
	// -------------------------------------------------------------------------
	// VModel model engine
	public edu.qrg.vmodel.VModel vmodel ();
	public edu.qrg.vmodel.VModel vmodel (edu.qrg.vmodel.VModel v);
	
} // interface Controller

// -----------------------------------------------------------------------------
// End of File: Controller.java       (c) 2001 Northwestern University