package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v5/code/src
// -----------------------------------------------------------------------------
// File name: QRGpanel.java
//    System: QRGutils
//   Version: 0.5
//    Author: Leo C. Ureel II
//   Created: February 12, 2002 18:52:54
//   Purpose: We need a standard panel that will exhibit certain standard 
//            properties such as easy printability.
// -----------------------------------------------------------------------------
// (c)2002 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Tuesday, February 12, 2002 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import javax.swing.*;

public class QRGpanel extends JPanel {
	public void print (Graphics g) {
		if (isOpaque()) super.print(g);
		else printComponents(g);
	} // method print
	public QRGpanel ( ) {
		super(new BorderLayout());
	} // constructor QRGpanel
} // class QRGpanel

// ----------------------------------------------------------------------------
// END OF FILE: QRGpanel.java                     2002 Northwestern University