package edu.qrg.vmodel.controllers.common;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.applet.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.awt.image.*;

import java.applet.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.awt.image.*;

public class ModelOverviewDialog extends JDialog implements VModelConstants, ActionListener, KeyListener {
	public class PrintProgressDialog extends JDialog {
		public JLabel label = null;
		public JProgressBar progressBar = null;
		public int maxPages = 0;
		public PrintProgressDialog ( ) {
			super(controller().frame(), "Print Progress");
			setModal( true );
			setSize( 200, 50 );
			setLocation( QRGutils.center(controller().frame().getSize(), getSize()));
			label = new JLabel( "Printing ..." );
			progressBar = new JProgressBar();
			getContentPane().setLayout(new BorderLayout());
			getContentPane().add(label, BorderLayout.NORTH);
			getContentPane().add(progressBar, BorderLayout.CENTER);
		} // constructor
		public void setPages ( int i ) { 
			maxPages = i; 
			label.setText( "Printing ..." );
			progressBar.setMinimum( 0 );
			progressBar.setMaximum( i );
			progressBar.setValue( 0 );
		} // method
		public void setPage ( int i ) {
			label.setText( "Printing " + i + " of " + maxPages );
			progressBar.setValue( i );
		} // method
		public void printModel ( ) {
			final PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((Frame) controller().frame(), "VModel", null);
			label.setText("Printing...");
			if (  pjob != null ) {
				try {
					Thread t = new Thread() {
						public void run () {
							printModelAux( pjob );
							setVisible( false );
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) { QRGutils.debugStackTrace( err ); }
				setVisible( true );
			} // end if
		} // method
		public void printPage ( ) {
			final PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((Frame) controller().frame(), "VModel", null);
			label.setText("Printing...");
			if (  pjob != null ) {
				try {
					Thread t = new Thread() {
						public void run () {
							printPageAux( pjob );
							setVisible( false );
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) { QRGutils.debugStackTrace( err ); }
				setVisible( true );
			} // end if
		} // method
	} // inner class
	protected PrintProgressDialog progress = null;
	public PrintProgressDialog progress ( ) {
		if (progress == null ) {
			progress = new PrintProgressDialog();
		} // end if
		return( progress );
	} // method

	protected boolean previewP = false;
	public boolean previewP () { return(previewP); }
	public boolean previewP (boolean b) { return(previewP = b); }

	protected Image pageImage = null;
	public Image pageImage () { return(pageImage); }
	public Image pageImage (Image i) { return(pageImage = i); }

	protected JButton done = null;
	public JButton done () { return(done); }
	public JButton done (JButton b) { return(done = b); }

	protected JButton printButton = null;
	public JButton printButton () {
		if (printButton == null) {
			printButton = new JButton("Print", ImageCache.getImage("print.gif"));
		} // end if
		return(printButton);
	} // reader
	
	protected JButton printPreviewButton = null;
	public JButton printPreviewButton () {
		if (printPreviewButton == null) {
			printPreviewButton = new JButton("Print Preview", ImageCache.getImage("printpreview.gif"));
			printPreviewButton.setToolTipText("Print Preview"); 
			printPreviewButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						showPreview();
					} // method
				}); // actionListener
		} // end if
		return(printPreviewButton);
	} // reader
	
	protected JButton modelOverviewButton = null;
	public JButton modelOverviewButton () {
		if (modelOverviewButton == null) {
			modelOverviewButton = new JButton("Model Overview", ImageCache.getImage("preview.gif"));
			modelOverviewButton.setToolTipText("Print Preview"); 
			modelOverviewButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						showOverview();
					} // method
				}); // actionListener
		} // end if
		return(modelOverviewButton);
	} // reader
	
	protected QRGpanel canvas = null;
	public QRGpanel canvas () { return(canvas); }
	public QRGpanel canvas (QRGpanel c) { return(canvas = c); }

	public Controller controller () { return((Controller) VModel.controller()); }

	protected int pageNumber = 0;
	public int pageNumber () { return(pageNumber); }
	public int pageNumber (int i) { return(pageNumber = i); }

	protected int pageMax = 1;
	public int pageMax () { return(pageMax); }
	public int pageMax (int i) { return(pageMax = i); }

//	protected Image pageImage = null;
//	public Image pageImage () { return(pageImage); }
//	public Image pageImage (Image i) { return(pageImage = i); }

	protected JButton back = null;
	public JButton back () { return(back); }
	public JButton back (JButton b) { return(back = b); }

	protected JButton forward = null;
	public JButton forward () { return(forward); }
	public JButton forward (JButton b) { return(forward = b); }

	protected JLabel info = null;
	public JLabel info () { return(info); }
	public JLabel info (JLabel l) { return(info = l); }

	protected JButton printPageButton = null;
	public JButton printPageButton () { return(printPageButton); }
	public JButton printPageButton (JButton b) { return(printPageButton = b); }

	protected JButton printAllButton = null;
	public JButton printAllButton () { return(printAllButton); }
	public JButton printAllButton (JButton b) { return(printAllButton = b); }
	
	public HTMLpanel coachPanel = null;
	
	protected boolean printingP = false;

// Be ashamed to die until you have won some victory for humanity.  -Horace Mann?
// ... I would be brave for there is much to dare. -Walter?

// "Poets have been mysteriously silent on the subject of cheese." G. K. Chesterton (1874 - 1936)

	// Methods
	// -----------------------------------------------------------------------
	public void showOverview () {
		Dimension s = null;
		Dimension ds = null;
		previewP(false);
		pageNumber(0);
		tools2().setVisible(false);
		// I think we need to manually resize because the dialog is modal and events are delayed.
		tools().setVisible(true);
		s = getSize();
		ds = done().getSize();
		tools().setSize(s.width - ds.width - 10, ds.height - 10);
		tools().setPreferredSize(tools().getSize());
		show();
	} // method

	public void showPreview () {
		Dimension s = null;
		Dimension ds = null;
		previewP(true);
		pageNumber(0);
		back().setEnabled(false);
		forward().setEnabled(true);
		tools().setVisible(false);
		tools2().setVisible(true);
		s = getSize();
		ds = done().getSize();
		tools2().setSize(s.width - ds.width - 10, ds.height - 10);
		tools2().setPreferredSize(tools2().getSize());
		show();
	} // method

	public void show () {
		ModelPane modelpane = controller().selectedWindow().modelPane();
		Model model = controller().currentModel();
		modelpane.deselectAll();
		controller().checkModel(model, Model.CHECKALL, true);
		Dimension size = modelpane.componentpane().getSize();
		int width = 0;
		int height = 0;
		int minX = size.width;
		int minY = size.height;
		int maxX = 0;
		int maxY = 0;
		Point fpos = null;
		Dimension fsiz = null;
		int fsizW = 0;
		int fsizH = 0;
		Instance instance = null;
		PeerElement peer = null;
		modelpane.reView();
		for(Enumeration instances = model.instances().elements(); instances.hasMoreElements();) {
			instance = (Instance) instances.nextElement();
			peer = (PeerElement) instance.peer();
			if (peer.isVisible()) {
//				peer.updatePeer();
				fpos = peer.getLocation();
				fsiz = peer.getSize();
				fsizW = fsiz.width;
				fsizH = fsiz.height;
				minX = (int) Math.min(minX, fpos.x);
				minY = (int) Math.min(minY, fpos.y);
				maxX = (int) Math.max(maxX, fpos.x + fsizW);
				maxY = (int) Math.max(maxY, fpos.y + fsizH);
			} // end if
		} // end for
		if (model.instances().isEmpty()) {
			minX = minY = 0;
			maxX = PAGE_WIDTH;
			maxY = PAGE_HEIGHT;
			width = maxX - minX;
			height = maxY - minY;
		} else {
			width = maxX - minX;
			height = maxY - minY;
		} // end if
		modelMinX = minX;
		modelMinY = minY;
		modelWidth = width;
		modelHeight = height;
		modelPagesX = (int)Math.ceil((width*1.0)/(PAGE_WIDTH * 1.0));
		modelPagesY = (int)Math.ceil((height * 1.0)/(PAGE_HEIGHT * 1.0));
		pageMax((int)Math.ceil((width*1.0)/(PAGE_WIDTH * 1.0)) * (int)Math.ceil((height * 1.0)/(PAGE_HEIGHT * 1.0)));
		if (previewP()) {
			pageImage(((JFrame) controller().frame()).createImage(PAGE_WIDTH + 44, PAGE_HEIGHT + 44));
			coachPanel = new HTMLpanel();
			coachPanel.setSize(PAGE_WIDTH, PAGE_HEIGHT);
			coachPanel.setPreferredSize(coachPanel.getSize());
			coachPanel.viewPane().setSize(PAGE_WIDTH, PAGE_HEIGHT);
			coachPanel.viewPane().setPreferredSize(coachPanel.getSize());
			String text = "<HTML><HEAD><TITLE>Ask Doc V.</TITLE></HEAD><BODY>";
			text += controller().updateContextHelp();
			text+="</BODY></HTML>";
			coachPanel.viewPane().setContentType("text/html");
			coachPanel.viewPane().setText(text);
			pageMax(-1 + pageMax() + (int) Math.ceil((1.0 * coachPanel.viewPane().getHeight()) / (1.0 * PAGE_HEIGHT)));
		} else pageImage(((JFrame) controller().frame()).createImage(width + 44, height + 44));
		if (previewP()) drawPage2(pageImage().getGraphics(), pageNumber());
		else drawPage(pageImage().getGraphics(), pageNumber());
		if (! printingP) {
			setModal(true);
			setTitle(VModel.preferences().getString("USERNAME") + " : " + controller().selectedModel().name());
			super.show();
			repaint();
		} // end  if
	} // method show
	
	public int modelMinX = 0;
	public int modelMinY = 0;
	public int modelWidth = 0;
	public int modelHeight = 0;
	public int modelPagesX = 0;
	public int modelPagesY = 0;

	public void drawCornerMarks (Graphics pg) {
		if (!printingP) {
			int width = pageImage().getWidth(null), height = pageImage().getHeight(null);
			pg.drawLine(0,0,0,32);
			pg.drawLine(0,0,32,0);
			pg.drawLine(width - 44 + 4,0,width - 44 + 4,32);
			pg.drawLine(width - 44 + 4,0,width - 44 + 4 - 32,0);
			pg.drawLine(0,height - 33 + 4,0,height - 33 + 4 - 32);
			pg.drawLine(0,height - 33 + 4,32,height - 33 + 4);
			pg.drawLine(width - 44 + 4,height - 33 + 4,width - 44 + 4,height - 33 + 4 - 32);
			pg.drawLine(width - 44 + 4,height - 33 + 4,width - 44 + 4 - 32,height - 33 + 4);
		} // end if
	} // method

	public void drawPage (Graphics pg, int pageNumber) {
		int minX = modelMinX;
		int minY = modelMinY;
		if (controller().selectedModel() != null) {
			int width = pageImage().getWidth(null), height = pageImage().getHeight(null);
			Rectangle clipbounds = pg.getClipBounds();
			if (clipbounds == null) clipbounds = new Rectangle(0,0,pageImage().getWidth(null),pageImage().getHeight(null));
	   			pg.setColor(WHITE);
					pg.fillRect(0,0,clipbounds.width + 5,clipbounds.height + 5);
					pg.setColor(BLACK);
					pg.translate(22,22);
					pg.drawLine(0,0,0,32);
					pg.drawLine(0,0,32,0);
					pg.drawLine(width - 44 + 4,0,width - 44 + 4,32);
					pg.drawLine(width - 44 + 4,0,width - 44 + 4 - 32,0);
					pg.drawLine(0,height - 44 + 4,0,height - 44 + 4 - 32);
					pg.drawLine(0,height - 44 + 4,32,height - 44 + 4);
					pg.drawLine(width - 44 + 4,height - 44 + 4,width - 44 + 4,height - 44 + 4 - 32);
					pg.drawLine(width - 44 + 4,height - 44 + 4,width - 44 + 4 - 32,height - 44 + 4);
					pg.setColor(WHITE);
					pg.translate(2,2);
					pg.setClip(0,0,width-44,height-44);
					pg.fillRect(0,0,width-44,height-44);
					drawguides(pg,width-44,height-44);
					pg.translate(-minX,-minY);
					controller().selectedWindow().modelPane().drawConnections(pg);
					controller().selectedWindow().modelPane().componentpane().printComponents(pg);
	   } // end if selectedModel
	} // end method drawPage

	public void drawPage2 (Graphics pg, int pageNumber) {
		int minX = modelMinX;
		int minY = modelMinY;
		if (controller().selectedModel() != null) {
				int width = pageImage().getWidth(null), height = pageImage().getHeight(null);
				Rectangle clipbounds = pg.getClipBounds();
				info().setText("Page " + (pageNumber + 1) + " of " + (pageMax() + 1));
				if (clipbounds == null) clipbounds = new Rectangle(0,0,pageImage().getWidth(null),pageImage().getHeight(null));
			if (pageNumber < (modelPagesX * modelPagesY)) {
				pg.setColor(WHITE);
				pg.fillRect(0,0,clipbounds.width + 5,clipbounds.height + 5);
				pg.setColor(BLACK);
				pg.translate(22,22);
				drawCornerMarks(pg);
				pg.drawString(controller().currentModel().getString("USERID") + " : " + controller().currentModel().name() + " : " + info().getText(), 2, height - 44 + 4 + 10);
				pg.setColor(WHITE);
				pg.translate(2,2);
				pg.setClip(0,0,width-44,height-44);
				pg.fillRect(0,0,width-44,height-44);
				drawguides2(pg,width-44,height-44, pageNumber);
				pg.translate(-minX-(((pageNumber / modelPagesY)  % modelPagesX)*PAGE_WIDTH),-minY-((pageNumber % modelPagesY)*PAGE_HEIGHT));
				controller().selectedWindow().modelPane().drawConnections(pg);
				controller().selectedWindow().modelPane().componentpane().printComponents(pg);
			} else {
				pg.setColor(WHITE);
				pg.fillRect(0,0,clipbounds.width + 5,clipbounds.height + 5);
				pg.setColor(BLACK);
				pg.translate(22,22);
				drawCornerMarks(pg);
				pg.drawString(controller().currentModel().getString("USERID") + " : " + controller().currentModel().name() + " : " + info().getText(), 2, height - 44 + 4 + 10);
				pg.setColor(WHITE);
				pg.translate(2,2);
				pg.setClip(0,0,width-44,height-44);
				pg.fillRect(0,0,width-44,height-44);
				drawguides2(pg,width-44,height-44, pageNumber);
				pg.translate(0,-(((pageNumber - (modelPagesX * modelPagesY)) % modelPagesY)*PAGE_HEIGHT));
				coachPanel.viewPane().print(pg);
			} // end if
		} // end if selectedModel
	} // end method drawPage

	public void drawguides (Graphics g,  int w, int h) {
		Color c = g.getColor();
		g.setColor(LIGHTBLUE);
		int page = 0;
		g.drawRect(0, 0, w-1, h-1);
		for(int x = 0; x < w; x += PAGE_WIDTH)
			g.drawLine(x, 0, x, h);
		for(int y = 0; y < h; y += PAGE_HEIGHT)
			g.drawLine(0, y, w, y);
		for(int x = 0; x < w; x += PAGE_WIDTH)
			for(int y = 0; y < h; y += PAGE_HEIGHT)
				g.drawString("Page " + ((page++)+1), x + 10, y + 20);
		g.setColor(c);
	} // method

	public void drawguides2 (Graphics g,  int w, int h, int page) {
		Color c = g.getColor();
		g.setColor(LIGHTBLUE);
		g.drawRect(0, 0, w-1, h-1);
		g.drawString("Page " + (page+1), 10, 20);
		g.setColor(c);
	} // method

	public void printPage () {
		progress().printPage();
	} // method

	public void printPageAux ( PrintJob pjob ) {
		progress().setPages( 1 );
		progress().setPage( 1 );
//		progress().show();
		try {
			if (controller().selectedModel() != null) {
//				PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((Frame) controller().frame(), "VModel", null);
//QRGutils.debug("ModelOverviewDialog.printPage", "resolution=" + pjob.getPageResolution() + " dimension=" + pjob.getPageDimension());				
				if (pjob != null) {
					printingP = true;
					show();
					printingP = false;
		     		ImageFilter filter = new RotateFilter(Math.PI / 2);
		     		ImageProducer producer = null;
		     		Image rotatedImage = null;
		     		Graphics pj = null;				
		     		producer = new FilteredImageSource(pageImage().getSource(), filter);
					//producer = new FilteredImageSource(canvas().getSource(), filter);
					rotatedImage = controller().frame().createImage(producer);
					pj = pjob.getGraphics();
					pj.drawImage(rotatedImage,50,50,null);
					//pj.drawImage(pageImage(),0,0,null);
					pjob.end();
				} // end if pjob
		   } // end if selectedModel
		} catch (Exception e) {
			QRGutils.debug("ModelOverviewDialog.printPage", "Error while printing.");
			QRGutils.debugStackTrace(e);
		} // end try-catch
		progress().label.setText("Done.");
//		progress().setVisible(false);
		show();
	} // method
	
	public void printModel() {
		progress().printModel( );
	} // method

	public void printModelAux( PrintJob pjob ) {
		boolean vis = isVisible();
		boolean prevP = previewP();
		int page = pageNumber();
		previewP(true);
//		progress().setPages(pageMax());
//		progress().show();
		try {
			if (controller().selectedModel() != null) {
//				PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((Frame) controller().frame(), "VModel", null);
				if (pjob != null) {
					printingP = true;
					for (int p = 0; p <= pageMax(); p++) {
						pageNumber(p);
						show();
		progress().setPages(pageMax());
		progress().setPage(p);
			     		ImageFilter filter = new RotateFilter(Math.PI / 2);
			     		ImageProducer producer = null;
			     		Image rotatedImage = null;
			     		Graphics pj = null;				
			     		producer = new FilteredImageSource(pageImage().getSource(), filter);
						//producer = new FilteredImageSource(canvas().getSource(), filter);
						rotatedImage = controller().frame().createImage(producer);
						pj = pjob.getGraphics();
						pj.drawImage(rotatedImage,50,50,null);
						//pj.drawImage(pageImage(),0,0,null);
					} // end for
					pjob.end();
					printingP = false;
				} // end if pjob
		   } // end if selectedModel
		} catch (Exception e) {
			QRGutils.debug("ModelOverviewDialog.printPage", "Error while printing.");
			QRGutils.debugStackTrace(e);
		} // end try-catch
		progress().label.setText("Done.");
//		progress().setVisible(false);
		previewP(prevP);
		pageNumber(page);
		if ( vis ) show();
		setVisible( vis );
	} // method

	// ActionListener methods
	// -----------------------------------------------------------------------
   public void actionPerformed(ActionEvent event) {
      Object source = event.getSource();
      if (source == back()) {
      	pageNumber(pageNumber() - 1);
      	if (pageNumber() < 0) pageNumber(0);
      	if (pageNumber() < pageMax()) forward().setEnabled(true);
      	else forward().setEnabled(false);
      	if (pageNumber() > 0) back().setEnabled(true);
      	else back().setEnabled(false);
      	drawPage2(pageImage().getGraphics(), pageNumber());
      	canvas().repaint();
      } else if (source == forward()) {
      	pageNumber(pageNumber() + 1);
      	if (pageNumber() > pageMax()) pageNumber(pageMax());
      	if (pageNumber() < pageMax()) forward().setEnabled(true);
      	else forward().setEnabled(false);
      	if (pageNumber() > 0) back().setEnabled(true);
       	else back().setEnabled(false);
      	drawPage2(pageImage().getGraphics(), pageNumber());
       	canvas.repaint();
     } else if (source == printPageButton()) {
      	if (pageImage() == null) 
      		pageImage(canvas().createImage(PAGE_WIDTH + 48, PAGE_HEIGHT));
	 		try {
				Thread t = new Thread() {
					public void run () {
			     		printPage();
					} // method run
				}; // Anonymous Class Thread
				t.start();
			} catch (Exception err) {}
      } else if ((source == printAllButton()) || (source == printButton())) {
//      		((MacClassroom)controller()).printModel();
		try {
			Thread t = new Thread() {
				public void run () {
					printModel();
				} // method run
			}; // Anonymous Class Thread
			t.start();
		} catch (Exception err) {}
      } else if (source == done()) {
      	setVisible(false);
      } // end if source
   } // method actionPerformed
   
	// KeyListener methods
	// -----------------------------------------------------------------------
	public void keyTyped(KeyEvent e) {
	} // method keyTyped
	
	public void keyPressed(KeyEvent e) {
		int kcode = e.getKeyCode();
		int kmod = e.getModifiers();
		// Window
		if ((kcode == KeyEvent.VK_W) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			setVisible(false);
	} // Method keyPressed
	
	public void keyReleased(KeyEvent e) {
	} // Method keyReleased
	
	protected JPanel buttons = new JPanel(new BorderLayout());
	public JPanel buttons () { return(buttons); }
	
	protected JToolBar tools = null;
	public JToolBar tools () { 
		if (tools == null) {
			tools = new JToolBar();
			tools.setFloatable(false);
			tools.setLayout(new GridLayout(1,18));
			tools().add(printButton());
			printButton().addActionListener(this);
			printButton().setEnabled(true);
			printButton().addKeyListener(this);
			tools().add(printPreviewButton());
			tools().addSeparator();
		} // end if
		return(tools); 
	} // reader
	
	protected JToolBar tools2 = null;
	public JToolBar tools2 () { 
		if (tools2 == null) {
			tools2 = new JToolBar();
			tools2.setFloatable(false);
			//tools2.setLayout(new GridLayout(1,18));

			back(new JButton(ImageCache.getImage("back.gif")));
			back().setToolTipText("View Previous Page");
			back().addActionListener(this);
			back().setEnabled(false);
			back().addKeyListener(this);
			tools2.add(back());
			forward(new JButton(ImageCache.getImage("forward.gif")));
			forward().setToolTipText("View Next Page");
			forward().addActionListener(this);
			forward().setEnabled(false);
			forward().addKeyListener(this);
			tools2.add(forward());
			info(new JLabel(" Page 1 of 1"));
			info().addKeyListener(this);
			tools2.add(info());
			tools2.addSeparator();
			printAllButton(new JButton(ImageCache.getImage("print.gif")));
			printAllButton().setToolTipText("Print All");
			printAllButton().addActionListener(this);
			printAllButton().setEnabled(true);
			printAllButton().addKeyListener(this);
			tools2.add(printAllButton());
			printPageButton(new JButton(ImageCache.getImage("printpage.gif")));
			printPageButton().setToolTipText("Print Page");
			printPageButton().addActionListener(this);
			printPageButton().setEnabled(true);
			printPageButton().addKeyListener(this);
			tools2.add(printPageButton());
			tools2.addSeparator();
			tools2.add(modelOverviewButton());
			tools2.addSeparator();
		} // end if
		return(tools2); 
	} // reader
	
	public ModelOverviewDialog() {
		tools().setVisible(true);
		tools2().setVisible(true);
		addKeyListener(this);
		buttons().add(tools(), BorderLayout.CENTER);
		buttons().addKeyListener(this);
		done(new JButton("Done"));
		done().addActionListener(this);
		done().setEnabled(true);
		done().addKeyListener(this);
		buttons.add(done(), BorderLayout.EAST);
		buttons.add(tools(), BorderLayout.CENTER);
		buttons.add(tools2(), BorderLayout.WEST);
		getContentPane().add(buttons, BorderLayout.SOUTH);
		getContentPane().addKeyListener(this);
		
		canvas(new QRGpanel() {
			public void paint (Graphics g) {
				double xoff; // x offset of page start in window
				double yoff; // y offset of page start in window
				double scale; // scale factor to fit page in window
				double px = pageImage().getWidth(null);
				double py = pageImage().getHeight(null);
				double sx = canvas().getWidth() - 1;
				double sy = canvas().getHeight() - 1;
				g.setColor(WHITE);
				g.fillRect(0,0,g.getClipBounds().width,g.getClipBounds().height);
				if (px / py < sx / sy) { // center horizontally
					scale = sy / py;
					xoff = 0.5 * (sx - scale * px);
					yoff = 0;
				} else {// center vertically
					scale = sx / px;
					xoff = 0;
					yoff = 0.5 * (sy - scale * py);
				} // end if center
				g.translate((int) xoff, (int) yoff);
				g.drawImage(pageImage(), 0,0, (int) (px * scale), (int) (py * scale), null);
			} // method paint
		}); // canvas
		canvas.addKeyListener(this);
		getContentPane().add(canvas, "Center");
		setSize(640,480);
	} // constructor ModelOverviewDialog
	
} // class ModelOverviewDialog
