package edu.qrg.vmodel.controllers.classic;

import edu.qrg.vmodel.*;
import edu.qrg.vmodel.controllers.common.*;
import edu.qrg.utils.*;
//import edu.qrg.utils.KeyValuePair.KVPinterface;
//import edu.qrg.vmodel.controllers.classic.ModelPane.Action;
import edu.qrg.vmodel.VModel.VMController;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyVetoException;
import java.io.File;
import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Math;
import java.lang.Object;
import java.lang.Runnable;
import java.lang.String;
import java.util.Enumeration;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultDesktopManager;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDesktopPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.JViewport;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.SwingUtilities;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ListDataListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.Timer;
import javax.swing.JWindow;
//import java.awt.image.BufferedImage;
//import com.sun.image.codec.*;
//import com.sun.image.codec.jpeg.*;
//import com.sun.image.codec.jpeg.JPEGImageEncoder.*;
import com.sun.jimi.core.*;			// Added TRH
import com.sun.jimi.core.options.*;	// Added TRH
import java.awt.*;
import java.awt.datatransfer.*; //Clipboard
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
//import java.awt.print.*;
//import java.awt.geom.*;
//import java.awt.geom.Line2D.Double;
import java.awt.image.*;
//import java.awt.image.BufferedImage;
import java.net.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers/Classic
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Classic.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: Classic
* Purpose: Classic VModel Interface Controller
* ----------------------------------------------------------------------------
* </PRE> */
public class Classic extends edu.qrg.vmodel.VModel implements Controller {
	// Constructors
	// -------------------------------------------------------------------------
	public Classic () {
//		QRGutils.debug("Wrong Constructor Called!!!!!!!!!");
	} // constructor
	
	public Classic (edu.qrg.vmodel.VModel v) {
		self(this);
		vmodel(v);
		init();
	} // constructor

	// Properties & Accessors
	// -------------------------------------------------------------------------
	// self
	protected Classic self = null;
	public Classic self () { return(self); }
	public Classic self (Classic c) { return(self = c); }

	// VModel model engine
	protected edu.qrg.vmodel.VModel vmodel = null;
	public edu.qrg.vmodel.VModel vmodel () { return(vmodel); }
	public edu.qrg.vmodel.VModel vmodel (edu.qrg.vmodel.VModel v) { return(vmodel = v); }
	
	// Load specified controller class
	public void init () {
		controller(this);
		
		if (userIsDeveloper()) SoundCache.playSound("fanfare.au");
			
		initDone = true;
	} // method init
	
	public static boolean initDone = false;
	
	public void go () {
		edu.qrg.vmodel.controllers.classic.VModel.main(new String[0]);
	} // method go


} // class

// -----------------------------------------------------------------------------
// End of File: Classic.java       (c) 2001 Northwestern University