package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v5/code/source
// -----------------------------------------------------------------------------
// File name: VModelPanel.java
//    System: VModel
//   Version: 0.5
//    Author: Leo C. Ureel II
//   Created: February 12, 2002 18:52:54
//   Purpose: We need a standard panel that will exhibit certain standard 
//            properties such as easy printability.
// -----------------------------------------------------------------------------
// (c)2002 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Tuesday, February 12, 2002 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import javax.swing.*;

public class VModelPanel extends QRGpanel {
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }
	
	public VModelPanel ( ) { super(); }

	public VModelPanel ( VModelGUI gui) {
		super();
		gui(gui);
		addKeyListener(gui);
	} // method print
} // class VModelPanel

// ----------------------------------------------------------------------------
// END OF FILE: VModelPanel.java                  2002 Northwestern University